<ComClass(OpenDoorNavisionPad.ClassId, OpenDoorNavisionPad.InterfaceId, OpenDoorNavisionPad.EventsId)> Public Class OpenDoorNavisionPad
    Public Const ClassId As String = "1B883E97-B2CB-48cf-8B47-87AAA589C289"
    Public Const InterfaceId As String = "FC8C3B3E-1D69-414e-A2FD-6394993C059A"
    Public Const EventsId As String = "EBC6EF56-7DD5-4555-A30A-B3BC0B8E11BF"

    Private mText As String

    Private mTextPointer As Integer
    Private mPrevTextPointer As Integer
    Private mPrevSeperator As Integer
    Private mTextFieldLength As Integer
    Private mDialogResult As Boolean
    Private mFormTitle As String

    Public Sub New()
        mTextPointer = 1
        mPrevTextPointer = 1
        mPrevSeperator = 0

        mFormTitle = "Open Door Navision Pad"
    End Sub

    Public Property TextFieldLength() As Integer
        Get
            Return mTextFieldLength
        End Get
        Set(ByVal Value As Integer)
            mTextFieldLength = Value
        End Set
    End Property
    Public Property Text() As String
        Get
            Return mText
        End Get
        Set(ByVal Value As String)
            mText = Value
        End Set
    End Property
    Public ReadOnly Property EOS() As Boolean
        Get
            If Count() <= mTextPointer Then
                Return True
            Else
                Return False
            End If
        End Get
    End Property
    Public ReadOnly Property TextPointer() As Integer
        Get
            Return mTextPointer
        End Get
    End Property
    Public Property FormTitle() As String
        Get
            Return mFormTitle
        End Get
        Set(ByVal Value As String)
            mFormTitle = Value
        End Set
    End Property
    Public ReadOnly Property Count() As Integer
        Get
            Return mText.Length
        End Get
    End Property

    Public ReadOnly Property DialogResultOK() As Boolean
        Get
            Return mDialogResult
        End Get
    End Property

    Public Sub ShowDialog()
        Dim frmNavisionPadEditor As New frmNavisionPad(Me)

        frmNavisionPadEditor.Text = mFormTitle
        frmNavisionPadEditor.ShowDialog()
        If frmNavisionPadEditor.DialogResult = DialogResult.OK Then
            mDialogResult = True
        Else
            mDialogResult = False
        End If

        frmNavisionPadEditor = Nothing
    End Sub

    Public Sub AppendText(ByVal ptext As String)
        mText &= ptext
    End Sub

    Public Sub ResetTextPointer()
        mTextPointer = 0
    End Sub

    Public Sub GetNextTextField(ByRef ReturnText As String, ByRef ReturnSeperator As Integer)
        'In Navision, the seperator is an option.  An option can be used as an integer
        ' 0 = no seperator
        ' 1 = space
        ' 2 = carriage return

        SetTextPointer(ReturnSeperator)
        ReturnText = Mid(mText, mPrevTextPointer, (mTextPointer - mPrevTextPointer))

    End Sub

    Private Sub SetTextPointer(ByRef Seperator As Integer)

        Select Case mPrevSeperator
            Case 1 'space
                mTextPointer += 1
            Case 2 'carriage return
                mTextPointer += 1
        End Select

        mPrevTextPointer = mTextPointer

        'first find new carriage return
        If Not SetTextPointerToNextCR() Then
            If (Count() - mTextPointer) > TextFieldLength Then
                If Not SetTextPointerToNextSpace() Then
                    SetTextPointerToFieldLength()
                    Seperator = 0
                Else
                    Seperator = 1
                End If
            Else
                SetTextPointerToFieldLength()
                Seperator = 0
            End If
        Else
            Seperator = 2
        End If


        'If mPrevTextPointer = mTextPointer Then
        '    'not moved ... never ending story
        '    mTextPointer += 1
        'End If

        mPrevSeperator = Seperator
    End Sub

    Private Function SetTextPointerToNextCR() As Boolean
        Dim TempPointerCR As Integer
        Dim char10 As Char
        char10 = Chr(10)

        TempPointerCR = InStr(mTextPointer, mText, char10)
        'Do While (TempPointerCR = mTextPointer)
        '    mTextPointer += 1
        '    TempPointerCR = InStr(mTextPointer, mText, char10)
        'Loop

        If (TempPointerCR <= 0) Then
            Return False
        Else
            If (TempPointerCR - mTextPointer) > mTextFieldLength Then
                Return False
            Else
                mTextPointer = TempPointerCR
                Return True
            End If
        End If

    End Function

    Private Function SetTextPointerToNextSpace() As Boolean
        Dim TempPointerSPACE As Integer
        Dim TempPointer As Integer
        Dim EndLoop As Boolean

        TempPointer = mTextPointer
        EndLoop = False
        Do While EndLoop = False
            TempPointer = InStr(TempPointer, mText, " ")
            If TempPointer = 0 Then
                EndLoop = True
            End If
            If (TempPointer - mTextPointer) > mTextFieldLength Then
                EndLoop = True
            Else
                TempPointerSPACE = TempPointer
                TempPointer += 1 'Pass current space (else endless loop)
            End If
        Loop
        TempPointer -= 1         'go back from previous space-passing

        If (TempPointerSPACE <= 0) Then
            Return False
        Else
            If (TempPointerSPACE - mTextPointer) > mTextFieldLength Then
                Return False
            Else
                mTextPointer = TempPointerSPACE
                Return True
            End If
        End If
    End Function

    Private Function SetTextPointerToFieldLength() As Boolean
        Dim TempPointerFL As Integer

        If (Count() - mPrevTextPointer) > mTextFieldLength Then
            mTextPointer += mTextFieldLength
        Else
            mTextPointer = Count() + 1
        End If
    End Function



End Class
